<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <template>
                <div v-if="rules.length === 0">
                    <AnimationComponent text="There are currently no rules. Create one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="0.8"/>
                </div>
                <ListPage v-else>
                    <RuleItem v-for="r in rules" :rule="r" :key="r.id">

                    </RuleItem>
                </ListPage>

                <q-fab color="accent" icon="add" direction="up" class="fixed-bottom-right q-ma-lg"
                       vertical-actions-align="right">
                    <q-fab-action color="primary" to="/rule/create/simple" icon="create" label="basic create">

                    </q-fab-action>
                    <q-fab-action color="secondary" to="/rule/create" icon="line_style" label="advance create">

                    </q-fab-action>
                    <q-tooltip anchor="center left" self="center right">
                        Create a new rule
                    </q-tooltip>

                </q-fab>
            </template>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import ListPage from "components/Core/ListPage.vue";
import SubContractorItem from "components/Entities/List/SubContractorItem.vue";
import {RulePrincipalResponse} from "src/classLibrary/APIModels/core/rulePrincipalResponse";
import RuleItem from "components/Entities/List/RuleItem.vue";

@Component({
    components: {RuleItem, SubContractorItem, ListPage, AnimationComponent, DocumentWrapper}
})
export default class Rules extends Vue {
    rules: RulePrincipalResponse[] = [];
    layoutTabs = [];

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    async loadRules() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<RulePrincipalResponse[]>(`Rule?projectId=${this.PersistentStore.StoreValue.project}`, null, t);
        r.match({
            err: (e) => p.Wrap.SubmitError(e),
            ok: (o) => {
                p.rules = o;
            }
        })
    }

    created() {
        this.loadRules();
    }
}
</script>
